/***************************************************************************
 *            chrono.c
 *
 *  Fri Nov 14 16:02:41 2003
 *  Copyright  2003  Arturo Montejo Raez
 *  arturo.montejo.raez@cern.ch
 ****************************************************************************/

#include "chrono.h"
#include "stdio.h"

void chrono_reset(Chrono *c, guint total_steps) 
{
	c->prev_time = time(NULL);
	c->accum_time = 0;
	c->total_steps = total_steps;
}

Chrono chrono_new(guint total_steps)
{
	Chrono c;
	chrono_reset(&c, total_steps);
	return c;
}

void chrono_dump(Chrono *c, guint act_step)
{
  guint remain_time = 0, h, m;
  time_t act_time = time(NULL);

	c->accum_time += act_time - c->prev_time;
	c->prev_time = act_time;
	if (act_step) 
		remain_time = (guint)(((double)c->accum_time/(double)act_step) * (double)(c->total_steps - act_step));
	h = remain_time/3600;
	remain_time %= 3600;
	m = remain_time/60;
	remain_time %= 60;
	printf("Remaining time: %dh%dm%ds", h, m, (guint)remain_time);
}
