/* --------------------------------------------------------------------------
   classrank.h
   Vector of ranked classes
----------------------------------------------------------------------------- */

#include <glib.h>
#include "bitset.h"
#include "sample.h"

typedef GArray *ClassRank;

ClassRank classrank_new(guint size);
void classrank_free(ClassRank *cr);
void classrank_add(ClassRank *cr, guint id, gdouble weight);
void classrank_avg(ClassRank *cr);

/* Return the 'ntop' classes. If ntop is zero all classes are
   returned.

   NOTE: the sample returned must be dealloacted by the caller. */
Sample classrank_get_top(ClassRank cr, guint ntop);

/* Same as above, but for last ones first */
Sample classrank_get_bottom(ClassRank cr, guint nbottom);

void classrank_dump(ClassRank cr);
