/* 
   Exponentiated-gradient algorithm.
   Proposed by Kivinen & Warmuth
*/

#ifndef __EG_H
#define __EG_H

#include <glib.h>
#include "samples.h"
#include "weights.h"

typedef struct eg_struct
{
  double eta;            /* algorithm parameters */

  /* model */
  Weights w;             /* weights */
  double t;              /* decission boundary */          

} *EG;


void *eg_new(gchar *args);
void eg_free(void **cp);
void eg_save(void *cp, gchar *file);
void *eg_new_read(gchar *file);
double eg_classify(void *cp, Sample s);
void eg_dump (void* cp);
void eg_learn(void **cp, Samples ss);

#endif /* __EG_H */
