/* 
   Genetic algorithm
*/

#ifndef __GENETIC_H
#define __GENETIC_H

#ifdef __cplusplus
extern "C" {
#endif

#include <glib.h>
#include "samples.h"
#include "weights.h"

#ifdef __cplusplus
}
#endif

typedef struct genetic_struct
{
  void *genome;         // genome representation
  gint popsize;        // size of population
  gint ngen;           // number of generations (stop criteria)
  gdouble pmut;         // probability of mutation
  gdouble pcross;       // probability of crossover

  // temporal pointer to samples
  Samples ss;

} *Genetic;

#ifdef __cplusplus
extern "C" {
#endif
  
  void *genetic_new(gchar *args);
  void genetic_free(void **cp);
  void genetic_save(void *cp, gchar *file);
  void *genetic_new_read(gchar *file);
  double genetic_classify(void *cp, Sample s);
  void genetic_dump (void* cp);
  void genetic_learn(void **cp, Samples ss);

#ifdef __cplusplus
}
#endif

#endif /* __GENETIC_H */
