#ifndef __PLAUM_H
#define __PLAUM_H

#include <glib.h>
#include "sample.h"
#include "samples.h"
#include "weights.h"

typedef struct plaum_struct
{
  int T;                                /* epochs */
  double neg_tau, pos_tau, eta, lambda; /* algorithm parameters */

  /* model */
  Weights w;                            /* weights */
  double b;

} *Plaum;

void *plaum_new(gchar *args);
void plaum_free(void **cp);
void plaum_save(void *cp, gchar *file);
void plaum_append_save(void *cp, gchar *file);
void plaum_save_ascii(void* cp, gchar *file, IntStrTable term_str, GArray *idid);
void *plaum_new_read(gchar *file);
void *plaum_new_read_at(FILE *f);
double plaum_classify(void *cp, Sample s);
void plaum_dump (void* cp);
void plaum_learn(void **cp, Samples ss);

#endif /* __PLAUM_H */
