#ifndef __ROCCHIO_H
#define __ROCCHIO_H

#include <glib.h>
#include "sample.h"
#include "samples.h"
#include "weights.h"

typedef struct rocchio_struct
{
  double alpha, beta, gamma;         /* algorithm parameters */
  gboolean nonnegative;              /* set negative values to 0 or not */
  
  /* model */
  double t;                          /* decission boundary */
  Weights w;                         /* weights */

} *Rocchio;


void *rocchio_new(gchar *args);
void rocchio_free(void **cp);
void rocchio_save(void *cp, gchar *file);
void *rocchio_new_read(gchar *file);
double rocchio_classify(void *cp, Sample s);
void rocchio_dump (void* cp);
void rocchio_learn(void **cp, Samples ss);

#endif /* __ROCCHIO_H */
