#ifndef __WIDROW_HOFF_H
#define __WIDROW_HOFF_H

#include <glib.h>
#include "sample.h"
#include "samples.h"
#include "weights.h"

typedef struct widrow_hoff_struct
{
  double eta;            /* algorithm parameters */
  gboolean average;      /* use average of computed weights (if true, default)
			    or last computed weight (otherwise) */
  double t;              /* threshold (decission boundary) */

  /* model */
  Weights w;                         /* weights */

} *WidrowHoff;


void *widrow_hoff_new(gchar *args);
void widrow_hoff_free(void **cp);
void widrow_hoff_save(void *cp, gchar *file);
void *widrow_hoff_new_read(gchar *file);
double widrow_hoff_classify(void *cp, Sample s);
void widrow_hoff_dump (void* cp);
void widrow_hoff_learn(void **cp, Samples ss);

#endif /* __WIDROW_HOFF_H */
