/***************************************************************************
 *            doc_info.c
 *
 *  Thu Nov 27 14:03:55 2003
 *  Copyright  2003  Arturo Montejo Raez
 *  arturo.montejo.raez@cern.ch
 ****************************************************************************/

#include <stdio.h>
#include "doc_info.h"
#include "tc_utils.h"

/* -------------------------------------------------------------------------- */
/* Reads an array of doc info from disk */
DocInfoArray doc_info_new_read(gchar *filepath)
{
  DocInfoArray doc_info;
  FILE *fhnd;
  guint len; 

  if (!(fhnd = fopen(filepath, "rb"))) 
    tc_error("class_info_new_read: Unable to open info file\n"); 
  doc_info = g_array_new(FALSE, TRUE, sizeof(DocInfo)); 
  fread(&len, sizeof(guint), 1, fhnd); 
  doc_info = g_array_set_size(doc_info, len); 
  fread(doc_info->data, sizeof(DocInfo), len, fhnd); 
  fclose(fhnd);
	
  return doc_info;	
}
/* -------------------------------------------------------------------------- */
DocInfo *doc_info_get(DocInfoArray doc_info, guint index) 
{
  return &g_array_index(doc_info, DocInfo, index);
}
/* -------------------------------------------------------------------------- */
void doc_info_free(DocInfoArray *doc_info) 
{
  g_array_free(*doc_info, TRUE);
}
/* -------------------------------------------------------------------------- */
/* Saves to disk */
void
doc_info_save(DocInfoArray doc_info, gchar *filepath)
{
  FILE *fhnd;
  if (!(fhnd = fopen(filepath, "wb"))) 
    tc_error("doc_info_save: Unable to create file\n"); 
  fwrite(&doc_info->len, sizeof(guint), 1, fhnd); 
  fwrite(doc_info->data, sizeof(DocInfo), doc_info->len, fhnd); 
  fclose(fhnd);
}
