/***************************************************************************
 *            doc_info.h
 *
 *  Thu Nov 27 14:00:38 2003
 *  Copyright  2003  Arturo Montejo Raez
 *  arturo.montejo.raez@cern.ch
 ****************************************************************************/

#ifndef _DOC_INFO_H
#define _DOC_INFO_H

#include <glib.h>

/* ---------------------------------------------------------------------------
   Data definitions and macros
   --------------------------------------- */

typedef struct doc_info_struct
{
	guint size;		/* number of terms (with duplicates, not just unique terms) */
	guint cf;		/* number of classes attached to */
	guint max_tf;		/* maximal term frequency in the document */
	long offset;		/* offset to the vectors file */
} DocInfo;

typedef GArray *DocInfoArray;

/* ---------------------------------------------------------------------------
   Functions declarations
   --------------------------------------- */

/* Reads an array of doc info from disk */
DocInfoArray 
doc_info_new_read(gchar *filepath);

void 
doc_info_free(DocInfoArray *doc_info);

void
doc_info_save(DocInfoArray doc_info, gchar *filepath);

DocInfo *
doc_info_get(DocInfoArray doc_info, guint index);


#endif /* _DOC_INFO_H */
