/***************************************************************************
 *            folds.h
 *
 *  Thu Nov 27 16:19:25 2003
 *  Copyright  2003  Arturo Montejo Raez
 *  arturo.montejo.raez@cern.ch
 ****************************************************************************/

#ifndef _FOLDS_H
#define _FOLDS_H

#include <glib.h>
#include "model.h"
#include "inverted_index.h"
#include "method.h"
#include "methods.h"
#include "feature.h"
#include "fold.h"

/*
	Folds attributes
*/
typedef struct folds_struct {
	gchar *path;            /* path to folds */
	gchar *filepath_ii;
	gchar *filepath_idx;
	InvertedIndex folds;    /* documents distribution */
	guint len;              /* number of folds */
	guint it;				/* iterator */
} *Folds;

#define FOLDS_FILE_II "folds.ii"
#define FOLDS_FILE_IDX "folds.idx"

/* Distributes documents in model 'model' into 'n' different folds */
Folds folds_new(Model model, FoldTrainParams *params);

void folds_free(Folds *folds);
Folds folds_new_read(gchar *path);
void folds_train(Folds *folds, Model m, FoldTrainParams *params);
void folds_test(Folds *folds, Model m, guint by_what, FoldTrainParams *params);
void folds_classify(Folds *folds, Model m, FeatureTransformations ftrans, gchar *document);
void folds_classify_huge(Folds *folds, Model m, FeatureTransformations ftrans, gchar *document);
#endif /* _FOLDS_H */
