/***************************************************************************
 *            intstr_table.c
 *
 *  Mon Oct 27 11:26:38 2003
 *  Copyright  2003  Arturo Montejo Raez
 *  arturo.montejo.raez@cern.ch
 ****************************************************************************/

#include "intstr_table.h"

/* -------------------------------------------------------------------------- */

void 
__intstr_table_set_string(gpointer key, gpointer value, gpointer user_data)
{
  /* 'key' is the string
     'value' the pointer to the integer id
     'user_data' is the pointer to the array
  */
  gchar **str = 
    &g_array_index((IntStrTable)user_data, gchar*, *(tc_id*)value);
  *str = g_strdup((const gchar *)key);
}

IntStrTable 
intstr_table_new(StrIntTable tt) 
{
  IntStrTable sit = g_array_new(FALSE, TRUE, sizeof(gchar *));
  sit = g_array_set_size(sit, tt->max_id+1);
  g_hash_table_foreach(tt->table, __intstr_table_set_string, sit);
  return sit;
}

/* -------------------------------------------------------------------------- */
void 
intstr_table_free(IntStrTable *ist)
{
  guint i;
  for (i=0; i<(*ist)->len; i++)
    g_free(g_array_index((*ist), gchar*, i));
  g_array_free(*ist, TRUE);
}
/* -------------------------------------------------------------------------- */
void
intstr_table_dump(IntStrTable ist) 
{
  guint i;
  for (i=0; i<ist->len; i++)
    printf("%d %s\n", i, g_array_index(ist, gchar*, i));  
}
/* -------------------------------------------------------------------------- */
gchar *
intstr_table_get(IntStrTable ist, tc_id index)
{
  return (gchar *)g_array_index(ist, gchar*, (guint)index);
}
