#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "stopper.h"
#include "tc_utils.h"

/* -------------------------------------------------------------------------- */
Stopper 
stopper_new(char *file) {
  Stopper stopper = (Stopper)g_hash_table_new_full(g_str_hash, g_str_equal, g_free, g_free);
  char strbuff[TC_BUFFER_LENGTH];
	
  FILE *f = fopen(file, "r");
  if (!f)
    tc_error_str("stopper_new: unable to open file '%s'\n", file);
  while (fscanf(f, "%s", strbuff) == 1)
    g_hash_table_insert(stopper, g_strdup(strbuff), g_strdup(""));
  fclose(f);
	
  return stopper;
}
/* -------------------------------------------------------------------------- */
void
stopper_free(Stopper *stopper) 
{
  g_hash_table_destroy(*stopper);
}
