#ifndef __STRINT_TABLE_H_
#define __STRINT_TABLE_H_

#include <glib.h>
#include "tc_types.h"

/* This is the translation table for strings into integers */
typedef struct strint_table_struct {
	GHashTable * table;
	tc_id max_id;
}* StrIntTable;

StrIntTable strint_table_new(void);
void strint_table_free(StrIntTable *tt);
tc_id strint_table_get(StrIntTable tt, gchar *str);
void strint_table_set(StrIntTable *tt, gchar *str, tc_id id);
void strint_table_filter_value(StrIntTable *tt, tc_id value);
void strint_table_dump(StrIntTable tt);

/* To write and read from disk */
StrIntTable strint_table_new_read(char *file);
void strint_table_save(StrIntTable tt, char *file);
											 
/* Macro for defining the trans_table_has_key function */
#define strint_table_has_key(tt, k) (strint_table_get(tt, k) != -1)

#endif /*__STRINT_TABLE_H_*/
