/***************************************************************************
 *            tm.h
 *
 *  Text Mining miscelaneous functions
 *
 *  arturo.montejo.raez@cern.ch
 ****************************************************************************/

#include <glib.h>
#include "bitset.h"
#include "tc_utils.h"
#include "tc_types.h"

inline double 
tm_plog2p (double z);

/* 
   Computes the information gain for a given item (term of class) to
   predict classes.
*/
double                                /* information gain value */
tm_infgain(BitSet *mclass_doc,        /* vector of bitsets for classes */
	   BitSet classes,            /* classes in the set */
	   BitSet j_docs,             /* set of documents of item j */
	   guint n,                   /* total documents in the set */
	   guint *cf);                /* returned class frequency for item */

/* 
   This function computes the imbalance degree of a class
*/
gdouble tm_imbalance_degree(guint ni, guint n);
